"use strict";

var _googleSpreadsheet = require("google-spreadsheet");

var _googleSpreadsheet2 = _interopRequireDefault(_googleSpreadsheet);

var _gatsbyNodeHelpers = require("gatsby-node-helpers");

var _gatsbyNodeHelpers2 = _interopRequireDefault(_gatsbyNodeHelpers);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } // gatsby-node.js


var _createNodeHelpers = (0, _gatsbyNodeHelpers2.default)({
  typePrefix: "GoogleSheet"
}),
    createNodeFactory = _createNodeHelpers.createNodeFactory;

exports.sourceNodes = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref, pluginOptions) {
    var boundActionCreators = _ref.boundActionCreators;
    var createNode, rootName, RootNode, doc, worksheets, items, rows;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            createNode = boundActionCreators.createNode;
            rootName = pluginOptions.rootName || "Sheet";
            RootNode = createNodeFactory(rootName);
            doc = new _googleSpreadsheet2.default(pluginOptions.spreadsheetKey);

            if (!pluginOptions.creds) {
              _context2.next = 7;
              break;
            }

            _context2.next = 7;
            return new Promise(function (resolve) {
              return doc.useServiceAccountAuth(pluginOptions.creds, resolve);
            });

          case 7:
            _context2.next = 9;
            return new Promise(function (resolve, reject) {
              return doc.getInfo(function (err, info) {
                if (err || !info.worksheets.length) reject(err);
                resolve(info.worksheets);
              });
            });

          case 9:
            worksheets = _context2.sent;
            _context2.next = 12;
            return worksheets.reduce(function () {
              var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(acc, sheet) {
                var rows;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return new Promise(function (resolve, reject) {
                          sheet.getRows(function (err, rows) {
                            if (err) reject(err);
                            resolve(rows);
                          });
                        });

                      case 2:
                        rows = _context.sent;
                        _context.next = 5;
                        return acc;

                      case 5:
                        _context.t0 = rows;
                        return _context.abrupt("return", _context.sent.concat(_context.t0));

                      case 7:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee, undefined);
              }));

              return function (_x3, _x4) {
                return _ref3.apply(this, arguments);
              };
            }(), Promise.resolve([]));

          case 12:
            items = _context2.sent;
            rows = items.forEach(function (item) {
              var itemNode = RootNode(item);
              createNode(itemNode);
            });

          case 14:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function (_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();